local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local Ingredient = GLOBAL.Ingredient
local require = GLOBAL.require
require "map/tasks"
require "constants"
require "components/builder"

local mergedGameTypes = {GLOBAL.RECIPE_GAME_TYPE.VANILLA,GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED,GLOBAL.RECIPE_GAME_TYPE.PORKLAND}
----------------------------------------------------------------------------------------------------------------------------
PrefabFiles = {
	"octohouse","octopus","octoatt",
	"watertentacle","wtentacle",
	"goldmonkey","goldentomb","goldbishop","goldobi",
	"summerwalrus","summerigloo","shadyglasses",
	"obsidianhelm","volcanicdetector",
	"nightmareboat", "nightmareboatwake",
	"tikihead","swplus_banana_tree","teepee","tikimask","tikiman","bananarang","totem","tikifire","wanawanatiki","tikistick"
}
Assets=
{
	Asset("ANIM", "anim/golden_monkey.zip"),
	Asset("ANIM", "anim/golden_tomb.zip"),
	Asset("ANIM", "anim/goldbishop_build.zip"),
	Asset("ANIM", "anim/golden_obi.zip"),
	Asset("ANIM", "anim/octo_house.zip"),
	Asset("ANIM", "anim/tentatt_build.zip"),
	--Asset("ANIM", "anim/octopus_build.zip"),
	Asset("ANIM", "anim/summer_igloo.zip"),
	Asset("ANIM", "anim/summer_walrus.zip"),
	Asset("ANIM", "anim/shady_glasses.zip"),
	Asset("ANIM", "anim/obsidian_protector.zip"),
	Asset("ANIM", "anim/water_tentacle.zip"),
	Asset("ANIM", "anim/wtentacle.zip"),
	Asset("ANIM", "anim/volco_meter.zip"),
	Asset("ANIM", "anim/tiki_head.zip"),
	Asset("ANIM", "anim/swplus_banana_tree.zip"),
	Asset("ANIM", "anim/teepee.zip"),
	Asset("ANIM", "anim/tikiman.zip"),
	Asset("ANIM", "anim/tiki_mask.zip"),
	Asset("ANIM", "anim/bananarang.zip"),
	Asset("ANIM", "anim/swap_bananarang.zip"),
	Asset("ANIM", "anim/wall_totem.zip"),
	Asset("ANIM", "anim/wanawana_build.zip"),
	Asset("ANIM", "anim/tiki_stick.zip"),
	--Asset("ANIM", "anim/tiki_build.zip"),
	
	Asset("ATLAS", "images/inventoryimages/shadyglasses.xml"),
	Asset("ATLAS", "images/inventoryimages/obsidianhelm.xml"),
	Asset("ATLAS", "images/inventoryimages/volcanicdetector.xml"),
	Asset("ATLAS", "images/inventoryimages/trident.xml"),
	Asset("ATLAS", "images/inventoryimages/nightmareboat.xml"),
	Asset("ATLAS", "images/inventoryimages/tikimask.xml"),
	Asset("ATLAS", "images/inventoryimages/tribal.xml"),
	Asset("ATLAS", "images/inventoryimages/bananarang.xml"),
	Asset("ATLAS", "images/inventoryimages/wall_totem_item.xml"),

	Asset("IMAGE", "minimap/goldtomb_icon.tex" ),
	Asset("ATLAS", "minimap/goldtomb_icon.xml" ),
	Asset("IMAGE", "minimap/octohouse_icon.tex" ),
	Asset("ATLAS", "minimap/octohouse_icon.xml" ),
	Asset("IMAGE", "minimap/tiki.tex" ),
	Asset("ATLAS", "minimap/tiki.xml" )
}
AddMinimapAtlas("minimap/octohouse_icon.xml")
AddMinimapAtlas("minimap/goldtomb_icon.xml")
----------------------------------------------------------------------------------------------------------------------------
--STRINGS
STRINGS.TIKI_TALK_FIND_LIGHT = {"O-O-SCARY", "O-O-SUN?", "O-O-FIRE", "O-O-GOOD", "O-O-WARM"}
STRINGS.TIKI_TALK_GO_HOME = {"O-O-HOME"}
STRINGS.TIKI_TALK_PANIC = {"O-O-HELP!", "O-O-WAAA!"}
STRINGS.WANA_TALK_FIGHT = {"DIE!", "INTRUDER!", "ME FIGHT YOU!"}
STRINGS.WANA_TALK_GOHOME = {"HOME"}
STRINGS.WANA_TALK_FIND_MEAT = {"MEAT", "NICE", "ME HUNGRY", "FOOD"}
STRINGS.WANA_TALK_TORCH = {"FIRE GOOD", "I AM FIREMASTER", "LET THERE BE LIGHT!"}
STRINGS.WANA_TALK_LOOKATWILSON = {"DO I KNOW YOU?", "ARE YOU NEW?", "NICE MASK"}

STRINGS.NAMES.OCTOHOUSE = "Octohouse"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.OCTOHOUSE = {"How do they even fit through the door?"}
STRINGS.NAMES.OCTOPUS = "Octopus"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.OCTOPUS = {"These guys sure are lazy."}

STRINGS.NAMES.GOLDMONKEY = "Golden Monkey"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDMONKEY = {"It's glorious!"}
STRINGS.NAMES.GOLDENTOMB = "Golden Orb"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDENTOMB = {"How shiny!"}
STRINGS.NAMES.GOLDBISHOP = "Golden Guardian"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDBISHOP = {"They don't look friendly."}

STRINGS.NAMES.SUMMERWALRUS = "MacTusk"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SUMMERWALRUS = {"He looks like he's enjoying his vacation."}
STRINGS.NAMES.SUMMERIGLOO = "Vacation Igloo"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SUMMERIGLOO = 
{
	EMPTY = "It's not the holiday season.",
	GENERIC = "Look's like its time for some fun in the sun!"
}
STRINGS.NAMES.SHADYGLASSES = "Shady Glasses"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SHADYGLASSES = {"These are so cool!"}

STRINGS.NAMES.WATERTENTACLE = "Aquatic Tentacle"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WATERTENTACLE = {"There could be more."}

STRINGS.NAMES.WTENTACLE = "Dead Tentacle"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WTENTACLE = {"I don't think I should eat this."}

STRINGS.NAMES.OBSIDIANHELM = "Obsidian Shielder"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.OBSIDIANHELM = {"This should protect me."}
STRINGS.RECIPE_DESC.OBSIDIANHELM = "Protection from the falling sky."

STRINGS.NAMES.IS_GOLDOBI = "Golden Obelisk"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.IS_GOLDOBI = {"I wish I could mine it."}
STRINGS.NAMES.S_GOLDOBI = "Golden Obelisk"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.S_GOLDOBI = {"I wish I could mine it."}

STRINGS.NAMES.VOLCANICDETECTOR = "Volcanic Transducer"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.VOLCANICDETECTOR = {"This should help to prepare us."}
STRINGS.RECIPE_DESC.VOLCANICDETECTOR = "Measures the volcano's fury."

STRINGS.CHARACTERS.GENERIC.DESCRIBE.TRIDENT = {"I should use this at sea."}
STRINGS.RECIPE_DESC.TRIDENT = "Gains power at sea."

STRINGS.NAMES.NIGHTMAREBOAT = "Nightmareboat"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NIGHTMAREBOAT = {"Thats one scary boat."}
STRINGS.RECIPE_DESC.NIGHTMAREBOAT = "Glides Across the ocean."

STRINGS.NAMES.TIKIHEAD = "Tiki Statue"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TIKIHEAD = {"How inspirational!"}
STRINGS.NAMES.SWPLUS_BANANA_TREE = "Banana Tree"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SWPLUS_BANANA_TREE = {"It grows bananas, what more can be said?"}
STRINGS.NAMES.TEEPEE = "Tribal Teepee"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TEEPEE = {"They won't let me in."}
STRINGS.NAMES.TIKIMAN = "Tribal Tiki"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TIKIMAN = {"So they do have a brain after all..."}
STRINGS.NAMES.TIKIMASK = "Tiki Mask"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TIKIMASK = {"How cultural!"}
STRINGS.RECIPE_DESC.TIKIMASK = "Blend in with the locals."
STRINGS.NAMES.BANANARANG = "Bananarang"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BANANARANG = {"It's healthy for me."}
STRINGS.RECIPE_DESC.BANANARANG = "Death by potassium!"
STRINGS.NAMES.WALL_TOTEM = "Totem"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WALL_TOTEM = {"I must build it."}
STRINGS.NAMES.WALL_TOTEM_ITEM = "Totem Piece"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WALL_TOTEM_ITEM = {"Lets get stacking!"}
STRINGS.RECIPE_DESC.WALL_TOTEM_ITEM = "Display your wealth."
STRINGS.NAMES.WANAWANATIKI = "Wanawana Tiki"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WANAWANATIKI = {"He looks like the leader."}
STRINGS.NAMES.TIKIFIRE = "Tiki Firepit"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TIKIFIRE = {"I'll let the firemaster fuel it."}
STRINGS.NAMES.TIKISTICK = "Tiki Stick"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TIKISTICK = {"For scaring off intruders."}
----------------------------------------------------------------------------------------------------------------------------
--NEW TECH TREE
STRINGS.TABS.TRIBAL = "Tribal"
--[tab_code_name] = {str = tab_code_name, sort= position, icon = symbol_file, icon_atlas = symbol_map}
RECIPETABS['TRIBAL'] = {str = "TRIBAL", sort=12, priority = 4, icon = "tribal.tex", icon_atlas = "images/inventoryimages/tribal.xml"}
TECH['TRIBAL_TWO'] = {TRIBAL = 2}
--UPDATE EXISTING TECHSTUFF
TECH.NONE = { SCIENCE = 0, MAGIC = 0, ANCIENT = 0, OBSIDIAN = 0, LOST = 0, TRIBAL = 0}
for k,v in pairs(TUNING.PROTOTYPER_TREES) do
    TUNING.PROTOTYPER_TREES[k].TRIBAL = 0
end
TUNING.PROTOTYPER_TREES.TRIBAL = {SCIENCE = 0, MAGIC = 0, ANCIENT = 0, OBSIDIAN = 0, WATER = 0, HOME = 0, CITY = 0, LOST = 0, TRIBAL = 2}
----------------------------------------------------------------------------------------------------------------------------
--RECIPES
local volcanicdetector = Recipe("volcanicdetector", {
	Ingredient("boards", 2),
	Ingredient("transistor", 2),
	Ingredient("obsidian", 1)
},
RECIPETABS.SCIENCE,  TECH.SCIENCE_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, "volcanicdetector_placer")
volcanicdetector.atlas = "images/inventoryimages/volcanicdetector.xml"
local trident = Recipe("trident", {
	Ingredient("spear", 1),
	Ingredient("walrus_tusk", 3),
	Ingredient("goldnugget", 5)
},
RECIPETABS.WAR,  TECH.SCIENCE_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED)
trident.atlas = "images/inventoryimages/trident.xml"
local cane = Recipe("cane", {
	Ingredient("walrus_tusk", 1),
	Ingredient("goldnugget", 5),
	Ingredient("twigs", 4)
},
RECIPETABS.DRESS,  TECH.SCIENCE_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED)
local nightmareboat = Recipe("nightmareboat",{
	Ingredient("nightmarefuel", 4),
	Ingredient("purplegem", 1)
},
RECIPETABS.NAUTICAL, TECH.MAGIC_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, "nightmareboat_placer", nil, nil, nil, true, 4)
nightmareboat.atlas = "images/inventoryimages/nightmareboat.xml"
local obsidianhelm = Recipe("obsidianhelm",{ 
	Ingredient("obsidian", 8),
	Ingredient("armorwood", 1),
	Ingredient("rope", 2)
},
RECIPETABS.OBSIDIAN, TECH.OBSIDIAN_TWO, mergedGameTypes, nil, nil, true)
obsidianhelm.atlas = "images/inventoryimages/obsidianhelm.xml"

--[[------------------------------------------------------
TRIBAL ITEM RECIPES
baseline: RECIPETABS.TRIBAL, {TRIBAL = 2}, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, placer?, nil, true)
]]
local tikimask = Recipe("tikimask",{ 
	Ingredient("boards", 2),
	Ingredient("pigskin", 1),
	Ingredient("rope", 2)
},
RECIPETABS.TRIBAL, TECH.TRIBAL_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, nil, nil, true)
tikimask.atlas = "images/inventoryimages/tikimask.xml"
local bananarang = Recipe("bananarang",{ 
	Ingredient("cave_banana", 4),
	Ingredient("silk", 2),
	Ingredient("cutgrass", 2)
},
RECIPETABS.TRIBAL, TECH.TRIBAL_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, nil, nil, true)
bananarang.atlas = "images/inventoryimages/bananarang.xml"
local wall_totem_item = Recipe("wall_totem_item",{ 
	Ingredient("goldnugget", 10),
	Ingredient("pigskin", 2),
	Ingredient("boards", 2)
},
RECIPETABS.TRIBAL, TECH.TRIBAL_TWO, GLOBAL.RECIPE_GAME_TYPE.SHIPWRECKED, nil, nil, true)
wall_totem_item.atlas = "images/inventoryimages/wall_totem_item.xml"
----------------------------------------------------------------------------------------------------------------------------
--POST GEN STUFF (OBSOLETE SINCE OCTOPUS HOUSES REDUNDANT) :( 
local a = math.random(0,2)
function SpawnOctoH()
	local pigking = GLOBAL.c_find("octopusking")

	if not pigking then return false end
		
	local x,y,z = pigking.Transform:GetWorldPosition()
	local is = false
	ents = GLOBAL.TheSim:FindEntities(x,y,z,9001)
	for k, v in pairs(ents) do
		if v.prefab == "octohouse" then
			is = true
		end
	end

	if pigking and not is then
		repeat
			local x,y,z = pigking.Transform:GetWorldPosition()
			local pig_shop = GLOBAL.SpawnPrefab("octohouse")
			x = x + math.random(8, 20)*((math.floor(math.random()*2)*2)-1)
			z = z + math.random(8, 20)*((math.floor(math.random()*2)*2)-1)
			pig_shop.Transform:SetPosition(x,y,z)
			a = a+1
		until(a>6)
	end
end

--local function spawn_task(inst)
	--inst:DoTaskInTime(5, SpawnOctoH)
--end

function builderpostinit(inst)
	local oldKnowsRecipe = inst.KnowsRecipe
	inst.KnowsRecipe = function(self, recname)
	local recipe=GLOBAL.GetRecipe(recname)
		if oldKnowsRecipe(self, recname) and not self.freebuildmode then
			if recipe and recipe.level.TRIBAL and recipe.level.TRIBAL > 0 then
				return false
			else
				return true
			end
		end	
		return oldKnowsRecipe(self, recname)
	end
end
--AddSimPostInit(SpawnOctoH) 
--AddPrefabPostInit("octopusking", spawn_task)
AddComponentPostInit("builder", builderpostinit)
----------------------------------------------------------------------------------------------------------------------------
