GLOBAL.require("map/tasks")
GLOBAL.require("constants")
GLOBAL.require("map/level")
local GROUND = GLOBAL.GROUND
local LOCKS = GLOBAL.LOCKS
local KEYS = GLOBAL.KEYS
local Layouts = GLOBAL.require("map/layouts").Layouts
local StaticLayout = GLOBAL.require("map/static_layout")
local LEVELTYPE = GLOBAL.LEVELTYPE
----------------------------------------------------------------------------------------------
--TIKI TRIBE
Layouts["tikitribe"] = StaticLayout.Get("map/static_layouts/tikitribe")
AddRoom("tikitribe_room", {
	colour={r=0.3,g=0.2,b=0.1,a=0.3},
	value = GROUND.JUNGLE,
	--tags = {"ExitPiece"},
	contents = {
		countstaticlayouts= {
			tikitribe = 1
		},
		countprefabs = {
			tikistick = math.random(2,5)
		},
		distributepercent = .25,
		distributeprefabs = {
			fireflies = 0.1,
			jungletree = .5,
			berrybush2 = .1,
			flower = .05,
			bambootree = 0.25,
			swplus_banana_tree = .05,
			bush_vine = .1,
		},
	}
})
AddTask("tikitribe_task", {
	locks=LOCKS.ISLAND2,
	keys_given={KEYS.ISLAND3},
	crosslink_factor=math.random(0, 1),
	make_loop=math.random(0, 100) < 50,
	room_choices={
		["tikitribe_room"] = 1,
		["JungleDense"] = 3,
		["BeachSand"] = 2,
	}, 
	room_bg=GROUND.JUNGLE,
	background_room="JungleDense",
	colour={r=1,g=0,b=0.6,a=1},
})
----------------------------------------------------------------------------------------------
--ELDORADO THE CITY OF GOLD!!
Layouts["eldorado"] = StaticLayout.Get("map/static_layouts/eldorado")
AddRoom("Eldorado_room", {
	colour={r=0.3,g=0.2,b=0.1,a=0.3},
	value = GROUND.JUNGLE,
	--tags = {"ExitPiece"},
	contents = {
		countstaticlayouts= {
			eldorado = 1
		},
		countprefabs = {
			primeapebarrel = 1,
		},
		distributepercent = .75,
		distributeprefabs = {
			fireflies = 0.1,
			jungletree = 1,
			goldnugget = 1,
			berrybush2 = .1,
			flower = .05,
			bambootree = 0.5,
			bush_vine = .1,
			is_goldobi = .1,
			s_goldobi = .1,
		},
	}
})
AddTask("Eldorado_task", {
	locks=LOCKS.ISLAND3,
	keys_given={KEYS.ISLAND4},
	crosslink_factor=math.random(.25, 1),
	make_loop=math.random(0, 100) < 50,
	room_choices={
		["Eldorado_room"] = 1,
	}, 
	room_bg=GROUND.JUNGLE,
	background_room="JungleDense",
	colour={r=1,g=0,b=0.6,a=1},
})
----------------------------------------------------------------------------------------------
--THE OCEAN IS A DANGEROUS PLACE
--You should watch out for Aquatic Tentacles
AddRoom("tentacle_ocean", {
	crosslink_factor=0,
	make_loop=0,
	colour={r=0.3,g=0.2,b=0.1,a=0.3},
	value = GROUND.OCEAN_DEEP,
	contents = {
		countprefabs = {
			watertentacle = 1,
		},
	}
})
AddTask("ocean_dangers", {
	locks=LOCKS.ISLAND4,
	keys_given={KEYS.ISLAND5},
	crosslink_factor=0,
	make_loop=0,
	room_choices={
		["tentacle_ocean"] = math.random(8,12),
	}, 
	room_bg=GROUND.OCEAN_DEEP,
	background_room="OceanDeep",
	colour={r=1,g=0,b=0.6,a=1},
})

--REMOVED OCTOPUS HOUSES BECAUSE BALLPHINS ARE BETTER, FEELSBADMAN
--Overwrite coral biome to include Octopus Houses
--AddRoomPreInit("WaterCoral", 
	--function(room)
		--room.contents.countprefabs = {} --Remove Octopus King from this biome
		--room.contents.distributeprefabs = {
			--fishinhole = .75,
			--coralreef = 1,
			--seaweed_planted = .3,
			--jellyfish_planted = .3, 
			--solofish = .3,
			--octohouse = .03 --REDUCED FROM .05
		--}
	--end
--)
--Including the amazing Octopus Town!
--AddRoom("OctoTown", {
	--colour={r=.5,g=0.6,b=.080,a=.10},
	--value = GROUND.OCEAN_CORAL,
		--contents =  {
			--countprefabs = {
				--octopusking = 1
			--},
		--distributepercent = 0.1,
		--distributeprefabs =
		--{
					--fishinhole = .2,
					--coralreef = .7,
					--seaweed_planted = .2,
					--jellyfish_planted = .1, 
					--octohouse = .3, -- REDUCED FROM .3
		--},
	--}
--})
--AddTask("OctoTown", {
	--locks=LOCKS.ISLAND5,
	--keys_given={KEYS.ISLAND6},
	--crosslink_factor=0,
	--make_loop=0,
	--room_choices={
		--["OctoTown"] = 1,
	--}, 
	--room_bg=GROUND.OCEAN_DEEP,
	--background_room="OceanDeep",
	--colour={r=1,g=0,b=0.6,a=1},
--})

----------------------------------------------------------------------------------------------
--WALRUS VACATION
Layouts["vacation"] = StaticLayout.Get("map/static_layouts/vacation")
AddRoom("walrusvacation", {
	colour={r=0.3,g=0.2,b=0.1,a=0.3},
	value = GROUND.BEACH,
	tags = {"Packim_Fishbone"},
	contents = {
		countstaticlayouts= {
			vacation = 1
		},
		distributepercent = .2,
		distributeprefabs= {
			sapling = 0.25,
			grass = .5,
			palmtree = .1,
			wildborehouse = .05,
			limpetrock = 0.1,
			sandhill = .3,
			seashell_beached = .125, 
		},
		countprefabs = {
			beachresurrector = 1,
		},
	}
})

AddTask("walrusvacation_task", {
	locks=LOCKS.ISLAND5,
	keys_given={KEYS.ISLAND6},
	crosslink_factor=math.random(.5, 1),
	make_loop=math.random(0, 100) < 50,
	room_choices={
		["walrusvacation"] = 1,
	}, 
	room_bg=GROUND.JUNGLE,
	background_room="BeachSand",
	colour={r=1,g=0,b=0.6,a=1},
})
-----------------------------------------------------------------------------------------
local function AddTaskTech(level)
	table.insert(level.tasks, "walrusvacation_task")
	table.insert(level.tasks, "Eldorado_task")
	table.insert(level.tasks, "tikitribe_task")
	table.insert(level.tasks, "ocean_dangers")
	--table.insert(level.tasks, "OctoTown")
end
AddLevelPreInit("SHIPWRECKED_DEFAULT", AddTaskTech)