local assets=
{
    Asset("ANIM", "anim/shady_glasses.zip"),
    Asset("ATLAS", "images/inventoryimages/shadyglasses.xml")
}

local function generic_perish(inst)
	inst:Remove()
end
local function shadyglasses_onequip(inst, owner)
		owner.AnimState:OverrideSymbol("swap_hat", "hat_shady_glasses", "swap_hat")
		owner.AnimState:Show("HAT")
		owner.AnimState:Hide("HAT_HAIR")
		owner.AnimState:Show("HAIR_NOHAT")
		owner.AnimState:Show("HAIR")
		
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAIR")
		inst.components.fueled:StartConsuming()
end
local function shadyglasses_onunequip(inst, owner)
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")
		inst.components.fueled:StopConsuming()
end
 

local function fn(Sim)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)

    anim:SetBank("beehat")
    anim:SetBuild("hat_shady_glasses")
    anim:PlayAnimation("anim")
	
	inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/shadyglasses.xml"
    inst:AddComponent("tradable")

    inst:AddComponent("dapperness")
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE

	inst:AddComponent("insulator")
	inst.components.insulator:SetInsulation(TUNING.INSULATION_MED)
	inst.components.insulator:SetSummer()
	
	inst:AddComponent("fueled")
	inst.components.fueled.fueltype = "USAGE"
	inst.components.fueled:InitializeFuelLevel(TUNING.WALRUSHAT_PERISHTIME)
	inst.components.fueled:SetDepletedFn(generic_perish)
	
     
    inst.components.equippable:SetOnEquip( shadyglasses_onequip )
    inst.components.equippable:SetOnUnequip( shadyglasses_onunequip )

    return inst
end
 
return Prefab( "common/inventory/shadyglasses", fn or simple, assets)