local assets=
{
	Asset("ANIM", "anim/wtentacle.zip"),
    Asset("ATLAS", "images/inventoryimages/wtentacle.xml"),
}
local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
	inst:AddTag("monstermeat")
    
	inst.AnimState:SetBuild("pigs_foot")
	inst.AnimState:SetBank("pigs_foot")
	inst.AnimState:PlayAnimation("idle")
    MakeInventoryFloatable(inst, "idle", "idle")

    inst:AddComponent("edible")
	inst.components.edible.foodtype = "MEAT"
	inst.components.edible.ismeat = true
    inst.components.edible.healthvalue = -5
    inst.components.edible.hungervalue = 25
    inst.components.edible.sanityvalue = -15
    
    -------
    inst:AddComponent("inspectable")
    
	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 20
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/wtentacle.xml"
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_SLOW)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"
	
	inst:AddComponent("cookable")
	inst.components.cookable.product = "trinket_12"
	
	inst:AddComponent("bait")
       
    return inst
end

AddIngredientValues({"tentacle"}, {meat=1}, true)

return Prefab( "common/inventory/wtentacle", fn, assets) 


	



 










