require("stategraphs/commonstates")
local actionhandlers = 
{
    ActionHandler(ACTIONS.GOHOME, "gohome"),
}

local events=
{
    CommonHandlers.OnStep(),
    CommonHandlers.OnLocomote(true,true),
    CommonHandlers.OnAttack(),
    CommonHandlers.OnAttacked(true),
    CommonHandlers.OnDeath(),
			EventHandler("locomote", 
				function(inst) 
					if inst.components.locomotor:WantsToMoveForward() then
						if not inst.sg:HasStateTag("run") and not inst.sg:HasStateTag("attack") then
							inst.sg:GoToState("run")
						end
					else
						if not inst.sg:HasStateTag("idle") then
							inst.sg:GoToState("idle")
						end
					end
				end),
}
local states=
{
    State{
        name = "idle",
		tags = {"idle", "canrotate"},
        onenter = function(inst, playanim)
			inst.sg:RemoveStateTag("run")
			inst.AnimState:PlayAnimation("run_loop", true)
        end,

		--events=
		--{

		--},
    },
    State{
        name = "run",
        tags = {"run", "canrotate"},
        onenter = function(inst, playanim)
			inst.AnimState:PlayAnimation("run_loop", true)
    		inst.components.locomotor:RunForward()            
        end,
    },
    State{
        name = "attack",
        tags = {"attack", "canrotate"},
        
        onenter = function(inst)
            --inst.SoundEmitter:PlaySound("dontstarve/pig/attack")
            --inst.SoundEmitter:PlaySound("dontstarve/wilson/attack_whoosh")
            inst.components.combat:StartAttack()
    		inst.components.locomotor:RunForward()
            inst.AnimState:PlayAnimation("run_loop", true)
        end,
        
        timeline=
        {
			TimeEvent(2*FRAMES, function(inst) inst.Transform:SetScale(1.4,1.5,1.5) end),
			TimeEvent(4*FRAMES, function(inst) inst.Transform:SetScale(1.3,1.5,1.5) end),
			TimeEvent(6*FRAMES, function(inst) inst.Transform:SetScale(1.2,1.5,1.5) end),
			TimeEvent(8*FRAMES, function(inst) inst.Transform:SetScale(1.1,1.5,1.5) end),
			TimeEvent(10*FRAMES, function(inst) inst.Transform:SetScale(1.75,1.5,1.5) end),
            TimeEvent(12*FRAMES,
				function(inst) 
					inst.components.combat:DoAttack()
					inst.sg:RemoveStateTag("attack") 
					inst.sg:RemoveStateTag("busy")
					inst.Transform:SetScale(1.5,1.5,1.5)
					inst.sg:GoToState("idle")
				end),
        },
        
        events=
        {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
}

return StateGraph("SGoctopus", states, events, "idle", actionhandlers)